searchData={"items":[{"type":"task","title":"mix tenant.gen.migration","doc":"Generates a migration.\n\nThe repository must be set under `:ecto_repos` in the\ncurrent app configuration or given via the `-r` option.","ref":"Mix.Tasks.Tenant.Gen.Migration.html"},{"type":"task","title":"Examples - mix tenant.gen.migration","doc":"mix tenant.gen.migration add_posts_table\n    mix tenant.gen.migration add_posts_table -r Custom.Repo\n\nBy default, the migration will be generated to the\n\"priv/YOUR_REPO/migrations\" directory of the current application\nbut it can be configured to be any subdirectory of `priv` by\nspecifying the `:priv` key under the repository configuration.\n\nThis generator will automatically open the generated file if\nyou have `ECTO_EDITOR` set in your environment variable.","ref":"Mix.Tasks.Tenant.Gen.Migration.html#module-examples"},{"type":"task","title":"Command line options - mix tenant.gen.migration","doc":"* `-r`, `--repo` - the repo to generate migration for","ref":"Mix.Tasks.Tenant.Gen.Migration.html#module-command-line-options"},{"type":"task","title":"PS - mix tenant.gen.migration","doc":"All of this code is copied from `mix ecto.gen.migration` task, if something\ndoes not work, please compare them and try to stay as close to it as possible.","ref":"Mix.Tasks.Tenant.Gen.Migration.html#module-ps"},{"type":"task","title":"mix tenant.migrate","doc":"Runs the pending tenant migrations for the given repository.\n\nTenant migrations are expected at \"priv/YOUR_REPO/tenant_migrations\" directory\nof the current application, where \"YOUR_REPO\" is the last segment\nin your repository name. For example, the repository `MyApp.Repo`\nwill use \"priv/repo/tenant_migrations\". The repository `Whatever.MyRepo`\nwill use \"priv/my_repo/tenant_migrations\".\n\nYou can configure a repository to use another directory by specifying\nthe `:priv` key under the repository configuration. The \"tenant_migrations\"\npart will be automatically appended to it. For instance, to use\n\"priv/custom_repo/tenant_migrations\":\n\n    config :my_app, MyApp.Repo, priv: \"priv/custom_repo\"\n\nTo change the \"tenant_migrations\" part, you can set the `:migrations_path`\nconfig under tenant configuration. For example, to use \"priv/repo/my_migrations\":\n\n    config :tenant, migrations_path: \"my_migrations\"\n\nThis task runs all pending tenant migrations by default. To migrate up to a\nspecific version number, supply `--to version_number`. To migrate a\nspecific number of times, use `--step n`.\n\nThe repositories to migrate are the ones specified under the\n`:ecto_repos` option in the current app configuration. However,\nif the `-r` option is given, it replaces the `:ecto_repos` config.\n\nSince Ecto tasks can only be executed once, if you need to migrate\nmultiple repositories, set `:ecto_repos` accordingly or pass the `-r`\nflag multiple times.\n\nIf a repository has not yet been started, one will be started outside\nyour application supervision tree and shutdown afterwards.","ref":"Mix.Tasks.Tenant.Migrate.html"},{"type":"task","title":"Examples - mix tenant.migrate","doc":"mix ecto.migrate\n    mix ecto.migrate -r Custom.Repo\n\n    mix ecto.migrate -n 3\n    mix ecto.migrate --step 3\n\n    mix ecto.migrate -v 20080906120000\n    mix ecto.migrate --to 20080906120000","ref":"Mix.Tasks.Tenant.Migrate.html#module-examples"},{"type":"task","title":"Command line options - mix tenant.migrate","doc":"* `-r`, `--repo` - the repo to migrate\n  * `--all` - run all pending migrations\n  * `--step` / `-n` - run n number of pending migrations\n  * `--to` - run all migrations up to and including version\n  * `--quiet` - do not log migration commands\n  * `--pool-size` - the pool size if the repository is started only for the task (defaults to 1)\n  * `--log-sql` - log the raw sql migrations are running\n  * `--strict-version-order` - abort when applying a migration with old timestamp\n  * `--no-compile` - does not compile applications before migrating\n  * `--no-deps-check` - does not check dependencies before migrating","ref":"Mix.Tasks.Tenant.Migrate.html#module-command-line-options"},{"type":"task","title":"PS - mix tenant.migrate","doc":"All of this code is copied from `mix ecto.migrate` task, if something does\nnot work, please compare them and try to stay as close to it as possible.","ref":"Mix.Tasks.Tenant.Migrate.html#module-ps"},{"type":"task","title":"mix tenant.migrations","doc":"Displays the up / down migration status for the given repository.\n\nThe repository must be set under `:ecto_repos` in the\ncurrent app configuration or given via the `-r` option.\n\nBy default, migrations are expected at \"priv/YOUR_REPO/migrations\"\ndirectory of the current application but it can be configured\nby specifying the `:priv` key under the repository configuration.\n\nIf the repository has not been started yet, one will be\nstarted outside our application supervision tree and shutdown\nafterwards.","ref":"Mix.Tasks.Tenant.Migrations.html"},{"type":"task","title":"Examples - mix tenant.migrations","doc":"mix tenant.migrations\n    mix tenant.migrations -r Custom.Repo","ref":"Mix.Tasks.Tenant.Migrations.html#module-examples"},{"type":"task","title":"Command line options - mix tenant.migrations","doc":"* `-r`, `--repo` - the repo to obtain the status for","ref":"Mix.Tasks.Tenant.Migrations.html#module-command-line-options"},{"type":"task","title":"mix tenant.mysql.install","doc":"Generates a migration to create the tenant table\nin the default database (MySQL only).","ref":"Mix.Tasks.Tenant.Mysql.Install.html"},{"type":"task","title":"mix tenant.rollback","doc":"Reverts applied migrations in the given repository.\n\nTenant migrations are expected at \"priv/YOUR_REPO/tenant_migrations\" directory\nof the current application, where \"YOUR_REPO\" is the last segment\nin your repository name. For example, the repository `MyApp.Repo`\nwill use \"priv/repo/tenant_migrations\". The repository `Whatever.MyRepo`\nwill use \"priv/my_repo/tenant_migrations\".\n\nYou can configure a repository to use another directory by specifying\nthe `:priv` key under the repository configuration. The \"migrations\"\npart will be automatically appended to it. For instance, to use\n\"priv/custom_repo/migrations\":\n\n    config :my_app, MyApp.Repo, priv: \"priv/custom_repo\"\n\nTo change the \"tenant_migrations\" part, you can set the `:migrations_path`\nconfig under tenant configuration. For example, to use \"priv/repo/my_migrations\":\n\n    config :tenant, migrations_path: \"my_migrations\"\n\nThis task runs all pending migrations by default. Runs the last\napplied migration by default. To roll back to a version number,\nsupply `--to version_number`. To roll back a specific number of\ntimes, use `--step n`. To undo all applied migrations, provide\n`--all`.\n\nThe repositories to rollback are the ones specified under the\n`:ecto_repos` option in the current app configuration. However,\nif the `-r` option is given, it replaces the `:ecto_repos` config.\n\nIf a repository has not yet been started, one will be started outside\nyour application supervision tree and shutdown afterwards.","ref":"Mix.Tasks.Tenant.Rollback.html"},{"type":"task","title":"Examples - mix tenant.rollback","doc":"mix ecto.rollback\n    mix ecto.rollback -r Custom.Repo\n\n    mix ecto.rollback -n 3\n    mix ecto.rollback --step 3\n\n    mix ecto.rollback --to 20080906120000","ref":"Mix.Tasks.Tenant.Rollback.html#module-examples"},{"type":"task","title":"Command line options - mix tenant.rollback","doc":"* `-r`, `--repo` - the repo to rollback\n  * `--all` - revert all applied migrations\n  * `--step` / `-n` - revert n number of applied migrations\n  * `--to` - revert all migrations down to and including version\n  * `--quiet` - do not log migration commands\n  * `--pool-size` - the pool size if the repository is started only for the task (defaults to 1)\n  * `--log-sql` - log the raw sql migrations are running\n  * `--no-compile` - does not compile applications before rolling back\n  * `--no-deps-check` - does not check dependencies before rolling back","ref":"Mix.Tasks.Tenant.Rollback.html#module-command-line-options"},{"type":"task","title":"PS - mix tenant.rollback","doc":"All of this code is copied from `mix ecto.rollback` task, if something does\nnot work, please compare them and try to stay as close to it as possible.","ref":"Mix.Tasks.Tenant.Rollback.html#module-ps"},{"type":"module","title":"Mix.Tenant","doc":"Useful functions for any tenant mix task.\n\nHere is the list of tasks we have for now:\n\n- [`mix tenant.gen.migration`](./Mix.Tasks.Tenant.Gen.Migration.html) -\ngenerates a tenant migration for the repo\n- [`mix tenant.migrate`](./Mix.Tasks.Tenant.Migrate.html) -\nruns the repository tenant migrations\n- [`mix tenant.migrations`](./Mix.Tasks.Tenant.Migrations.html) -\ndisplays the repository migration status\n- [`mix tenant.rollback`](./Mix.Tasks.Tenant.Rollback.html) -\nrolls back the repository tenant migrations","ref":"Mix.Tenant.html"},{"type":"function","title":"Mix.Tenant.ensure_started/2","doc":"Ensures the given repository is started and running.","ref":"Mix.Tenant.html#ensure_started/2"},{"type":"function","title":"Mix.Tenant.ensure_tenant_migrations_path/1","doc":"Ensures the migrations path exists for the given `repo`.\n\nReturns the path for the `repo` tenant migrations folder if succeeds\nor `Mix.raise`'s if it fails.","ref":"Mix.Tenant.html#ensure_tenant_migrations_path/1"},{"type":"function","title":"Mix.Tenant.restart_apps_if_migrated/2","doc":"Restarts the app if there was any migration command.","ref":"Mix.Tenant.html#restart_apps_if_migrated/2"},{"type":"function","title":"Mix.Tenant.run_tenant_migrations/3","doc":"Runs the tenant migrations with the given `args` and using\n`migrator` function.","ref":"Mix.Tenant.html#run_tenant_migrations/3"},{"type":"function","title":"Mix.Tenant.source_repo_priv/1","doc":"Returns the private repository path relative to the source.","ref":"Mix.Tenant.html#source_repo_priv/1"},{"type":"function","title":"Mix.Tenant.timestamp/0","doc":"Generates a nicely formatted timestamp","ref":"Mix.Tenant.html#timestamp/0"},{"type":"module","title":"Tenant","doc":"This is the main module of Tenant.\n\nThe main objective of it is to make a little bit easier to manage tenants\nthrough postgres db schemas or equivalents, executing queries and commands\ninside and outside the tenant without much boilerplate code.","ref":"Tenant.html"},{"type":"module","title":"Using the tenant - Tenant","doc":"This module has useful functions to manage your tenants, like `create/1`,\n`rename/2` and `drop/1`, but if you're trying to apply the tenant to a\nquery, changeset or schema, stay with your application `Repo`, sending the\nprefix. Like this:\n\n    Repo.all(User, prefix: Tenant.to_prefix(\"my_tenant\"))\n\nIt's a good idea to call `Tenant.to_prefix` on your tenant name, although is\nnot required. Because, if you configured a `tenant_prefix`, this function will\nreturn the prefixed one.","ref":"Tenant.html#module-using-the-tenant"},{"type":"function","title":"Tenant.all/2","doc":"Returns all the tenants on the given `repo`.","ref":"Tenant.html#all/2"},{"type":"function","title":"Tenant.config/0","doc":"Returns a `%Tenant.Config{}` struct with all the args loaded from the app\nconfiguration.","ref":"Tenant.html#config/0"},{"type":"function","title":"Tenant.create/2","doc":"Creates the given `tenant` on the given `repo`.\n\nReturns `{:ok, tenant}` if successful or `{:error, reason}` otherwise.\n\nBesides creating the database itself, this function also loads their\nstructure executing all migrations from inside\n`priv/YOUR_REPO/tenant_migrations` folder. By calling `create_schema/3`\nsending `migrate/2` as the `func` callback.\n\nSee `migrate/2` for more details about the migration running.","ref":"Tenant.html#create/2"},{"type":"function","title":"Ecto 3 migrations, tenant and transactions - Tenant.create/2","doc":"So on Ecto 3, migrations were changed to run on async tasks. Because of\nthat it's not possible anymore to run `Tenant.create/2` inside of a\ntransaction anymore.\n\nBut there is a way to achieve the same results using `create_schema/3`\nand `migrate/2`. Here is an example using transaction:\n\n    Repo.transaction(fn ->\n      {:ok, _} = Tenant.create(\"tenant\")\n      User.insert!(%{name: \"Demo user 1\"})\n      User.insert!(%{name: \"Demo user 2\"})\n    end)\n\nAnd here is how you could achieve the same results on success or fail:\n\n    Tenant.create_schema(\"tenant\", Repo, fn(tenant, repo) ->\n      Repo.transaction(fn ->\n        {:ok, _} = Tenant.migrate(tenant, repo)\n        User.insert!(%{name: \"Demo user 1\"})\n        User.insert!(%{name: \"Demo user 2\"})\n\n        # the `create_schema/3` function must return `{:ok, \"tenant\"}`\n        # if succeeded, and `Repo.transaction` transforms the function results\n        # on this tuple\n        tenant\n      end)\n    end)\n\nSo, if the function given to `create_schema/3` returns an error tuple, it will\nrollback the created schema and return that tuple to you. Check out\n`create_schema/3` docs for more details.","ref":"Tenant.html#create/2-ecto-3-migrations-tenant-and-transactions"},{"type":"function","title":"Tenant.create_schema/3","doc":"Creates the `tenant` schema/database on the given `repo`.\n\nReturns `{:ok, tenant}` if successful or `{:error, reason}` otherwise.\n\nAfter creating it successfully, the given `func` callback is called with\nthe `tenant` and the `repo` as arguments. The `func` must return\n`{:ok, any}` if successful or `{:error, reason}` otherwise. In the case\nthe `func` fails, this func will rollback the created schema and\nfail with the same `reason`.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenant.html#create_schema/3"},{"type":"function","title":"Tenant.drop/2","doc":"Drops the given tenant on the given `repo`.\n\nReturns `{:ok, tenant}` if successful or `{:error, reason}` otherwise.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenant.html#drop/2"},{"type":"function","title":"Tenant.exists?/2","doc":"Returns if the given `tenant` exists or not on the given `repo`.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenant.html#exists?/2"},{"type":"function","title":"Tenant.migrate/2","doc":"Migrates the given `tenant` on your `repo`.\n\nReturns `{:ok, migrated_versions}` if successful or `{:error, reason}` otherwise.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenant.html#migrate/2"},{"type":"function","title":"Tenant.migrations_path/1","doc":"Returns the path for the tenant migrations on your `repo`.","ref":"Tenant.html#migrations_path/1"},{"type":"function","title":"Tenant.rename/3","doc":"Renames the `old_tenant` to the `new_tenant` on the given `repo`.\n\nReturns `{:ok, new_tenant}` if successful or `{:error, reason}` otherwise.\n\nThe function `to_prefix/1` will be applied to the `old_tenant` and\n`new_tenant`.","ref":"Tenant.html#rename/3"},{"type":"function","title":"Tenant.reserved_tenant?/1","doc":"Returns if the given `tenant` is reserved or not.\n\nThe function `to_prefix/1` will be applied to the tenant.","ref":"Tenant.html#reserved_tenant?/1"},{"type":"function","title":"Tenant.reserved_tenants/0","doc":"Returns the list of reserved tenants.\n\nBy default, there are some limitations for the name of a tenant depending on\nthe database, like \"public\" or anything that start with \"pg_\".\n\nYou also can configure your own reserved tenant names if you want with:\n\n    config :tenant, reserved_tenants: [\"www\", \"api\", ~r/^db+$/]\n\nNotice that you can use regexes, and they will be applied to the tenant\nnames.","ref":"Tenant.html#reserved_tenants/0"},{"type":"function","title":"Tenant.tenant_field/1","doc":"Returns the value of the configured tenant field on the given `map`.","ref":"Tenant.html#tenant_field/1"},{"type":"function","title":"Tenant.to_prefix/2","doc":"Returns the `tenant` name with the given `prefix`.\n\nIf the `prefix` is omitted, the `tenant_prefix` configuration from\n`Tenant.Config` will be used.\n\nThe `tenant` can be a string, a map or a struct. For a string it will\nbe used as the tenant name to concat the prefix. For a map or a struct, it\nwill get the `tenant_field/0` from it to concat the prefix.","ref":"Tenant.html#to_prefix/2"},{"type":"module","title":"Tenant.Config","doc":"All the configuration for `Tenant` basic functionality is here:\n\n- `repo`: the ecto repo that will be used to execute the schema operations.\n- `tenant_prefix`: a prefix for all tenants.\n- `reserved_tenants`: a list of reserved tenants, which cannot be created\nthrough tenant APIs. The items here can be strings or regexes.\n- `tenant_field`: an atom with the name of the field to get the tenant name\nif the given tenant is a struct. By default it's `:id`.","ref":"Tenant.Config.html"},{"type":"module","title":"Tenant.EnsurePlug","doc":"This is a basic plug that ensure the tenant is loaded.\n\nTo plug it on your router, you can use:\n\n    plug Tenant.EnsurePlug,\n      callback: &TenantHelper.callback/2\n      failure_callback: &TenantHelper.failure_callback/2\n\nSee `Tenant.EnsurePlugConfig` to check all the allowed `config` flags.","ref":"Tenant.EnsurePlug.html"},{"type":"module","title":"Tenant.EnsurePlugConfig","doc":"This is a struct that holds the configuration for `Tenant.EnsurePlug`.\n\nHere are the config keys allowed:\n\n- `assign`: the name of the assign where we must save the tenant.\n- `callback`: function that might be called when the plug succeeded. It\nmust return a connection.\n- `failure_callback`: function that might be called when the plug failed.\nIt must return a connection.","ref":"Tenant.EnsurePlugConfig.html"},{"type":"module","title":"Tenant.ParamPlug","doc":"This is a basic plug that loads the current tenant assign from a given\nparam.\n\nTo plug it on your router, you can use:\n\n    plug Tenant.ParamPlug,\n      param: :subdomain,\n      tenant_handler: &TenantHelper.tenant_handler/1\n\nSee `Tenant.ParamPlugConfig` to check all the allowed `config` flags.","ref":"Tenant.ParamPlug.html"},{"type":"module","title":"Tenant.ParamPlugConfig","doc":"This is a struct that holds all configuration for `Tenant.ParamPlug`.\n\nHere are the config keys allowed:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.\n- `param`: the param name to load the tenant from.","ref":"Tenant.ParamPlugConfig.html"},{"type":"module","title":"Tenant.Plug","doc":"This module have some basic functions for our tenant plugs.\n\nThe plugs we have for now are:\n\n- `Tenant.ParamPlug` - loads the tenant from a body or query param\n- `Tenant.SessionPlug` - loads the tenant from a session param\n- `Tenant.SubdomainPlug` - loads the tenant from the url subdomain\n- `Tenant.EnsurePlug` - ensures the current tenant is loaded and halts if not","ref":"Tenant.Plug.html"},{"type":"function","title":"Tenant.Plug.ensure_tenant/2","doc":"Ensure the tenant is loaded, and if not, halts the `conn`.\n\nThe `config` map/struct must have:\n\n- `assign`: the name of the assign where we must save the tenant.","ref":"Tenant.Plug.html#ensure_tenant/2"},{"type":"function","title":"Tenant.Plug.put_tenant/3","doc":"Puts the given `tenant` as an assign on the given `conn`, but only if the\ntenant is not reserved.\n\nThe `config` map/struct must have:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.","ref":"Tenant.Plug.html#put_tenant/3"},{"type":"module","title":"Tenant.SessionPlug","doc":"This is a basic plug that loads the current tenant assign from a given\nvalue set on session.\n\nTo plug it on your router, you can use:\n\n    plug Tenant.SessionPlug,\n      session: :subdomain,\n      tenant_handler: &TenantHelper.tenant_handler/1\n\nSee `Tenant.SessionPlugConfig` to check all the allowed `config` flags.","ref":"Tenant.SessionPlug.html"},{"type":"module","title":"Tenant.SessionPlugConfig","doc":"This is a struct that holds the configuration for `Tenant.SessionPlug`.\n\nHere are the config keys allowed:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.\n- `session`: the session param name to load the tenant from.","ref":"Tenant.SessionPlugConfig.html"},{"type":"module","title":"Tenant.SubdomainPlug","doc":"This is a basic plug that loads the current tenant assign from a given\nvalue set on subdomain.\n\nTo plug it on your router, you can use:\n\n    plug Tenant.SubdomainPlug,\n      endpoint: MyApp.Endpoint,\n      tenant_handler: &TenantHelper.tenant_handler/1\n\nSee `Tenant.SubdomainPlugConfig` to check all the allowed `config` flags.","ref":"Tenant.SubdomainPlug.html"},{"type":"module","title":"Tenant.SubdomainPlugConfig","doc":"This is a struct that holds the configuration for `Tenant.SubdomainPlug`.\n\nHere are the config keys allowed:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.\n- `endpoint`: the Phoenix.Endpoint to get the host name to discover the\nsubdomain.","ref":"Tenant.SubdomainPlugConfig.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"v2.0.0 - Changelog","doc":"","ref":"changelog.html#v2-0-0"},{"type":"extras","title":"Renamed and development continued - Changelog","doc":"Due to no releases having been made in six years despite reaching out to the previous\ndevelopers repeatedly over multiple years, Triplex was forked and renamed to Tenant.","ref":"changelog.html#renamed-and-development-continued"},{"type":"extras","title":"Fixes - Changelog","doc":"- `Triplex.all` no longer returns tenants that do not match the configured rpefix (Aaron Seigo)\n- `Triplex.all` no longer returns prefixes (Andre Barr)\n- `mix triplex.migrations` fixed for Ecto 3 (Paul Ostazeski)","ref":"changelog.html#fixes"},{"type":"extras","title":"Improvements - Changelog","doc":"- Logging of SQL statements can be turned off with `config :tenant, log: false` (Thomas Cioppettini)\n- Use information schema as the default behaviour for MySQL driver (Hammam Samara)","ref":"changelog.html#improvements"},{"type":"extras","title":"Maintenance - Changelog","doc":"- De-duplicate the `timestamp/0` function (Aaron Seigo)\n- Support for myxql was added. Mariaex package was removed. Add the myxql package\n  e.g `{:myxql, \"~> 0.7\"}` in your `mix.exs` file.\n- Fix compiler warnings for Elixir >= 1.17 (Paul Ostazeski)","ref":"changelog.html#maintenance"},{"type":"extras","title":"Testing - Changelog","doc":"- ` TENANT_TEST_BACKENDS` environment variable introduced which controls which backends\n  to run tests for. A comma separated list of database names is expected.\n  Defaults to `pgsql,mysql` (Aaron Seigo)","ref":"changelog.html#testing"},{"type":"extras","title":"Documentation - Changelog","doc":"- Updated documentation (Kian-Meng Ang)","ref":"changelog.html#documentation"},{"type":"extras","title":"v1.3.0 (2019-05-31) - Changelog","doc":"","ref":"changelog.html#v1-3-0-2019-05-31"},{"type":"extras","title":"Bug fixes - Changelog","doc":"- Fixed compilation error when optional adapters are not included in downstream project.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Changed - Changelog","doc":"- docker-compose configuration that allows easy setup for test databases.\n- `Triplex.create/1,2` now rolls back the prefix creation if the `func` fails with error tuple\n- Now we support to Ecto 3! :tada: But be aware that this new version does not support\nthe old versions of Ecto, only 3.0 and up","ref":"changelog.html#changed"},{"type":"extras","title":"Breaking changes - Changelog","doc":"It's not our fault, but there is a breaking change if you upgrade it because migration on\nEcto 3 are ran on a different process.\n\nThe problem you may find is basically with this kind of code:\n\n```elixir\nRepo.transaction(fn ->\n  {:ok, _} = Triplex.create(\"tenant\")\n  User.insert!(%{name: \"Demo user 1\"})\n  User.insert!(%{name: \"Demo user 2\"})\nend)\n```\n\nAs `Triplex.create/1` runs the tenant migrations, and they will run on different processes,\nyou will get an error from your db saying that the given tenant prefix (schema or database\ndepending on the db) does not exist.\n\nThat occurs because the new processes will checkout a new connection to db, making them\nnot aware of the current transaction, since it is on another db connection. But don't panic,\nwe have a solution for you!\n\nHere is how you could achieve the same results on success or fail:\n\n```elixir\nTriplex.create_schema(\"tenant\", Repo, fn(tenant, repo) ->\n  Repo.transaction(fn ->\n    {:ok, _} = Triplex.migrate(tenant, repo)\n    User.insert!(%{name: \"Demo user 1\"})\n    User.insert!(%{name: \"Demo user 2\"})\n\n    tenant\n  end)\nend)\n```\n\nFor more details about these function check the online documentation for `Triplex.create/1,2`\nand `Triplex.create_schema/1,2,3`.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"v1.3.0-rc.1 (2019-03-07) - Changelog","doc":"","ref":"changelog.html#v1-3-0-rc-1-2019-03-07"},{"type":"extras","title":"Bug fixes - Changelog","doc":"- Fixed compilation error when optional adapters are not included in downstream project.","ref":"changelog.html#bug-fixes-1"},{"type":"extras","title":"Changed - Changelog","doc":"- docker-compose configuration that allows easy setup for test databases.","ref":"changelog.html#changed-1"},{"type":"extras","title":"v1.3.0-rc.0 (2019-03-03) - Changelog","doc":"","ref":"changelog.html#v1-3-0-rc-0-2019-03-03"},{"type":"extras","title":"Added - Changelog","doc":"- Support to MySQL :dolphin:","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- `Triplex.create/1,2` now rolls back the prefix creation if the `func` fails with error tuple\n- Now we support to Ecto 3! :tada: But be aware that this new version does not support\nthe old versions of Ecto, only 3.0 and up","ref":"changelog.html#changed-2"},{"type":"extras","title":"Breaking changes - Changelog","doc":"It's not our fault, but there is a breaking change if you upgrade it because migration on\nEcto 3 are ran on a different process.\n\nThe problem you may find is basically with this kind of code:\n\n```elixir\nRepo.transaction(fn ->\n  {:ok, _} = Triplex.create(\"tenant\")\n  User.insert!(%{name: \"Demo user 1\"})\n  User.insert!(%{name: \"Demo user 2\"})\nend)\n```\n\nAs `Triplex.create/1` runs the tenant migrations, and they will run on different processes,\nyou will get an error from your db saying that the given tenant prefix (schema or database\ndepending on the db) does not exist.\n\nThat occurs because the new processes will checkout a new connection to db, making them\nnot aware of the current transaction, since it is on another db connection. But don't panic,\nwe have a solution for you!\n\nHere is how you could achieve the same results on success or fail:\n\n```elixir\nTriplex.create_schema(\"tenant\", Repo, fn(tenant, repo) ->\n  Repo.transaction(fn ->\n    {:ok, _} = Triplex.migrate(tenant, repo)\n    User.insert!(%{name: \"Demo user 1\"})\n    User.insert!(%{name: \"Demo user 2\"})\n\n    tenant\n  end)\nend)\n```\n\nFor more details about these function check the online documentation for `Triplex.create/1,2`\nand `Triplex.create_schema/1,2,3`.","ref":"changelog.html#breaking-changes-1"},{"type":"extras","title":"Contributing","doc":"# Contributing\n\nHere is a step by step for contributing to the project:\n\n- Fork the project\n- Create a branch for your feature/fix\n- Make it happen\n- Create tests for it\n- Make sure to run `mix format`\n- Also, give `mix credo` a check, we enforce no warning on CI build\n- Don't forget to add the changes you made to `CHANGELOG.md`\n- Open a PR\n- Wait for review!","ref":"contributing.html"},{"type":"extras","title":"Releasing - Contributing","doc":"Here is the step by step to release the project (team members only):\n\n- Change the `version` key on `mix.exs` to the version you'll release\n- Commit it to `master`\n- Make sure CI passes and docs are good\n- Prepare the version branch:\n  - If you're releasing a major or minor, open a branch for it, with a naming like `1.0`\n  - If you're releasing a patch with all the things on master, checkout the minor branch and\n  `git rebase master` on it\n  - If you're releasing a patch, but can't get everything of master, `git cherry-pick  ` of\n  every commit you need, adapt if needed and push it\n- Create a draft for your release on Github\n  - From branch: `1.0`\n  - Tag: `v1.0.0`\n  - Release name: `1.0.0`\n  - Description: exactly the same as changelog\n- Run `mix hex.publish`\n- Submit your release draft\n- Update `README.md` version","ref":"contributing.html#releasing"},{"type":"extras","title":"License","doc":"# The MIT License\n\nCopyright 2017 ateliware\nCopyright 2019 The Tenant AUTHORS\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Tenant\n\n[![Module Version](https://img.shields.io/hexpm/v/tenant.svg)](https://hex.pm/packages/tenant)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/tenant/)\n\nA simple and effective way to build multitenant applications on top of Ecto.\n\n[Documentation](https://hexdocs.pm/tenant/readme.html)\n\nTenant leverages database data segregation techniques (such as [Postgres schemas](https://www.postgresql.org/docs/current/static/ddl-schemas.html)) to keep tenant-specific data separated, while allowing you to continue using the Ecto functions you are familiar with.","ref":"readme.html"},{"type":"extras","title":"Quick Start - Overview","doc":"1. Add `tenant` to your list of dependencies in `mix.exs`:\n\n   ```elixir\n   def deps do\n     [\n       {:tenant, \"~> 2.0.0\"},\n     ]\n   end\n   ```\n\n2. Run in your shell:\n\n   ```bash\n   mix deps.get\n   ```","ref":"readme.html#quick-start"},{"type":"extras","title":"Configuration - Overview","doc":"Configure the Repo you will use to execute the database commands with:\n\n    config :tenant, repo: ExampleApp.Repo","ref":"readme.html#configuration"},{"type":"extras","title":"Testing - Overview","doc":"The unit tests run, by default, against both PostgreSQL and MySQL. It is possible to run the tests\nagainst only one or the other by setting the `TENANT_TEST_BACKENDS` environment variable to a\ncomma-separated list. The recognized values are `pgsql` and `mysql`.\n\nThis command would run only the PostgreSQL tests:\n\n    TENANT_TEST_BACKENDS=\"pgsql\" mix test","ref":"readme.html#testing"},{"type":"extras","title":"Additional configuration for MySQL - Overview","doc":"In MySQL, each tenant will have its own MySQL database.\nTenant used to use a table called `tenants` in the main Repo to keep track of the different tenants.\nIf you wish to keep this behavior, generate the migration that will create the table by running:\n\n```bash\nmix tenant.mysql.install\n```\n\nAnd then create the table:\n\n```bash\nmix ecto.migrate\n```\n\nFinally, configure Tenant to use the `tenants` table:\n\n```elixir\nconfig :tenant, tenant_table: :\"information_schema.schemata\"\n```\n\nOtherwise, Tenant will continue to use the `information_schema.schemata` table as the default behavior for storing tenants.","ref":"readme.html#additional-configuration-for-mysql"},{"type":"extras","title":"Usage - Overview","doc":"Here is a quick overview of what you can do with tenant!","ref":"readme.html#usage"},{"type":"extras","title":"Creating, renaming and dropping tenants - Overview","doc":"#### To create a new tenant:\n\n```elixir\nTenant.create(\"your_tenant\")\n```\n\nThis will create a new database schema and run your migrations—which may take a while depending on your application.\n\n\n#### Rename a tenant:\n\n```elixir\nTenant.rename(\"your_tenant\", \"my_tenant\")\n```\n\nThis is not something you should need to do often. :-)\n\n\n#### Delete a tenant:\n\n```elixir\nTenant.drop(\"my_tenant\")\n```\n\nMore information on the API can be found in [documentation](https://hexdocs.pm/tenant/Tenant.html#content).","ref":"readme.html#creating-renaming-and-dropping-tenants"},{"type":"extras","title":"Creating tenant migrations - Overview","doc":"To create a migration to run across tenant schemas:\n\n```bash\nmix tenant.gen.migration your_migration_name\n```\n\nIf migrating an existing project to use Tenant, you can move some or all of your existing migrations from `priv/YOUR_REPO/migrations` to  `priv/YOUR_REPO/tenant_migrations`.\n\nTenant and Ecto will automatically add prefixes to standard migration functions.  If you have _custom_ SQL in your migrations, you will need to use the [`prefix`](https://hexdocs.pm/ecto/Ecto.Migration.html#prefix/0) function provided by Ecto. e.g.\n\n```elixir\ndef up do\n  execute \"CREATE INDEX name_trgm_index ON #{prefix()}.users USING gin (nam gin_trgm_ops);\"\nend\n```","ref":"readme.html#creating-tenant-migrations"},{"type":"extras","title":"Running tenant migrations: - Overview","doc":"```bash\nmix tenant.migrate\n```\n\nThis will migrate all of your existing tenants, one by one.  In the case of failure, the next run will continue from where it stopped.","ref":"readme.html#running-tenant-migrations"},{"type":"extras","title":"Using Ecto - Overview","doc":"Your Ecto usage only needs the `prefix` option.  Tenant provides a helper to coerce the tenant value into the proper format, e.g.:\n\n```elixir\nRepo.all(User, prefix: Tenant.to_prefix(\"my_tenant\"))\nRepo.get!(User, 123, prefix: Tenant.to_prefix(\"my_tenant\"))\n```","ref":"readme.html#using-ecto"},{"type":"extras","title":"Fetching the tenant with Plug - Overview","doc":"Tenant includes configurable plugs that you can use to load the current tenant in your application.\n\nHere is an example loading the tenant from the current subdomain:\n\n```elixir\nplug Tenant.SubdomainPlug, endpoint: MyApp.Endpoint\n```\n\nFor more information, check the `Tenant.Plug` documentation for an overview of our plugs.","ref":"readme.html#fetching-the-tenant-with-plug"},{"type":"extras","title":"Thanks - Overview","doc":"This lib is inspired by the gem [apartment](https://github.com/influitive/apartment), which does the same thing in Ruby on Rails world. We also give credit (and a lot of thanks) to @Dania02525 for the work on [apartmentex](https://github.com/Dania02525/apartmentex).  A lot of the work here is based on what she has done there.  And also to @jeffdeville, who forked ([tenantex](https://github.com/jeffdeville/tenantex)) taking a different approach, which gave us additional ideas.","ref":"readme.html#thanks"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright 2017 ateliware\nCopyright 2019 The Tenant AUTHORS\n\nThis work is free. You can redistribute it and/or modify it under the\nterms of the MIT License. See the [LICENSE.md](./LICENSE.md) file for more details.","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}